PAGE ,132
TITLE 19200 Baud Communications Enabler, Version 1.00, 06-Apr-1987

BIOS      SEGMENT AT 40H
RS232BASE LABEL   WORD
BIOS      ENDS

CODE      SEGMENT BYTE

          ORG     80H

PARAM     LABEL   BYTE

          ORG     100H

          ASSUME  CS:CODE

INS_FLAG  LABEL   WORD
START:    JMP     INSTALL

SIGNON    DB      "19200 Baud Communications Enabler, Version 1.00",13,10,"$"
SIGNEND   LABEL   BYTE
SIGNLEN   EQU     OFFSET SIGNEND-OFFSET INS_FLAG

INT14VEC  LABEL   DWORD
INT14OFF  DW      ?
INT14SEG  DW      ?

DIVISOR   LABEL   WORD                          ; Divisor for 19200 is 6
DIV_LSB   DB      6                             ;   ( 38400 = 3)
DIV_MSB   DB      0                             ;   ( 57600 = 2)
                                                ;   (115200 = 1)
BAUD_NUM  DB      0

INT14     PROC    FAR

          CMP     AH,0                          ; If Not INIT COM PORT,
          JNE     INT14_1
          PUSH    AX                            ;   or not correct baud rate,
          AND     AL,0E0H
          CMP     AL,BAUD_NUM
          POP     AX
          JE      INT14_2
INT14_1:  JMP     INT14VEC                      ;   Perform Old INT 14 Vector
INT14_2:  STI                                   ; Enable Interrupts
          PUSH    DS                            ; Save Registers
          PUSH    DX
          PUSH    SI
          PUSH    CX
          PUSH    BX
          PUSH    AX                            ; Point to BIOS Data Segment
          MOV     AX,BIOS
          MOV     DS,AX

          ASSUME  DS:BIOS

          POP     AX
          MOV     SI,DX                         ; Read COM Port Address
          SHL     SI,1
          MOV     DX,RS232BASE[SI]
          OR      DX,DX                         ; If Zero, Bypass
          JZ      INT14_3
          MOV     AH,AL                         ; Enable Divisor Latch Access
          ADD     DX,3
          MOV     AL,80H
          OUT     DX,AL
          DEC     DX                            ; Divisor Latch MSB = 0
          DEC     DX
          MOV     AL,DIV_MSB
          OUT     DX,AL
          DEC     DX                            ; Divisor Latch LSB = 6
          MOV     AL,DIV_LSB
          OUT     DX,AL
          ADD     DX,3                          ; Set Comm Parameters
          MOV     AL,AH
          AND     AL,1FH
          OUT     DX,AL
          DEC     DX                            ; Clear Interrupt Enable Reg
          DEC     DX
          MOV     AL,0
          OUT     DX,AL
          ADD     DX,4                          ; Get COMM Status for Return
          IN      AL,DX
          MOV     AH,AL
          INC     DX
          IN      AL,DX
INT14_3:  POP     BX                            ; Restore Registers
          POP     CX
          POP     SI
          POP     DX
          POP     DS
          IRET                                  ; Done

INT14     ENDP

          ASSUME  DS:CODE

CHK_INS:  MOV     AX,CS                         ; Data Segment = Code Segment
          MOV     DS,AX
          MOV     DX,AX
          DEC     DX
          MOV     INS_FLAG,0FFFFH               ; Set INSTALLED Flag
          XOR     AX,AX                         ; Start Search at Segment 0
          MOV     ES,AX
CHK_INS1: MOV     SI,OFFSET INS_FLAG            ; Point to Signature
          MOV     CX,SIGNLEN                    ; Set Signature Length
          MOV     DI,SI                         ; Destination Offset = Source
          REPE    CMPSB                         ; Compare Source w/Destination
          JE      CHK_INS3                      ; If Equal, Done
          MOV     AX,ES                         ; Increment Segment
          INC     AX
          MOV     ES,AX
          CMP     AX,DX                         ; If Less Than This Segment,
          JBE     CHK_INS1                      ;   Repeat
CHK_INS3: RET                                   ; Done

INSTALL:  MOV     AH,9                          ; Output SignOn Message
          MOV     DX,OFFSET SIGNON
          INT     21H
          MOV     DX,OFFSET COPYRIGHT           ; Output Copyright Message
          INT     21H
          CALL    CHK_INS                       ; If Not Yet Installed,
          JE      INSTALL1
          PUSH    ES
          MOV     AX,3514H                      ;   Read Old INT 14 Vector
          INT     21H
          MOV     INT14OFF,BX                   ;   Save Old INT 14 Vector
          MOV     INT14SEG,ES
          POP     ES
          MOV     AX,2514H                      ;   Set New INT 14 Vector
          MOV     DX,OFFSET INT14
          INT     21H
          MOV     AH,9                          ;   Output INSTALLED Message
          MOV     DX,OFFSET INSTALLED
          INT     21H
INSTALL1: MOV     SI,OFFSET PARAM               ; Point to Parameter String
          LODSB                                 ; Read Parameter Length
          CBW
          MOV     BX,AX
          MOV     BYTE PTR [SI][BX],0           ; Terminate Parameter String
INSTALL2: LODSB                                 ; Strip Off Leading WhiteSpace
          CMP     AL,' '
          JE      INSTALL2
          CMP     AL,9
          JE      INSTALL2
          OR      AL,AL                         ; If End-of-Parameter, Done
          JZ      INSTALL6
          DEC     SI                            ; Read Parameter
          LODSW
          MOV     BX,OFFSET BAUDRATE            ; Test For Baud Rate Match
          MOV     CX,8
INSTALL3: CMP     AX,[BX]
          JE      INSTALL4
          ADD     BX,4
          LOOP    INSTALL3
          JMP     SHORT INSTALL5
INSTALL4: MOV     AL,8                          ; If Match, Set Baud Rate Flag
          SUB     AL,CL
          MOV     CL,5
          SHL     AL,CL
          MOV     ES:BAUD_NUM,AL
          JMP     SHORT INSTALL6
INSTALL5: MOV     AH,9                          ; Else Error
          MOV     DX,OFFSET PARM_ERR
          INT     21H
INSTALL6: MOV     AL,ES:BAUD_NUM                ; Output Baud Rate Message
          MOV     CL,5
          SHR     AL,CL
          CBW
          MOV     BX,AX
          PUSH    ES
          PUSH    DS
          POP     ES
          SHL     BX,1
          SHL     BX,1
          LEA     SI,BAUDRATE[BX]
          MOV     DI,OFFSET BAUD_MSG
          MOV     CX,4
          REP     MOVSB
          MOV     AH,9
          MOV     DX,OFFSET BAUD_MSG
          INT     21H
          POP     AX
          MOV     BX,DS                         ; If Not Yet Resident,
          CMP     AX,BX
          JNE     INSTALL7
          MOV     DX,OFFSET INSTALL[15]         ;   Install
          MOV     CL,4
          SHR     DX,CL
          MOV     AX,3100H                      ;   Terminate and Stay Resident
          INT     21H
INSTALL7: MOV     AX,4C00H                      ; Else Exit to DOS
          INT     21H

BAUDRATE  DB      "110 150 300 600 1200240048009600"
COPYRIGHT DB      "SMG Software",13,10
          DB      "(C) Copyright 1987 Steven M. Georgiades",13,10,10,"$"
INSTALLED DB      "19200 is now installed.",13,10,10,"$"
PARM_ERR  DB      "Illegal Parameter!",7,13,10,10,"$"
BAUD_MSG  DB      "110  Baud is replaced by 19200 Baud.",13,10,10,"$"

CODE      ENDS

          END     START
